


#include <SDL\SDL.h>


#include "muGUI_widget.h"

//#include "KBFLite.h"
#include "BFont.h"
#include "SDL_prim.h"


#define		nSX2_WID_VIDEO_OUTPUT		0
#define		nSX2_WID_EMU_OUTPUT			1
#define		nSX2_WID_OPCODE_OUTPUT		2
#define		nSX2_WID_REGISTER_OUTPUT	3

#define		muGUI_MAX_WIDGET	256

#define		muGUI_STATUS_RUNNING	1
#define		muGUI_STATUS_STOP		2	

#define		TRUE 	1
#define		FALSE 	0


typedef struct _muGUI {
	
	SDL_Surface * MainScreen;
	
	//KBF_Font *font;
    BFont_Info *Font1;
	BFont_Info *Font2;

	
	unsigned int	nbWidget;
	unsigned char	status;
	
		
	muGUIwidget myWid[muGUI_MAX_WIDGET];
	
	
	void (*addWidget)( void * , muGUIwidget *);
	void (*clearScreen) (void * );
	
	void (*run)(void * );
	void (*destroy)(void * );
	
	void (*IdleProc)(void);

	
} muGUI;

extern muGUI nSX2GUI;


int muGUI_Init ( muGUI * fgui );
void muGUI_Destroy (  void * this ) ;
void muGUI_MainLoop (  void * this ) ;
void muGUI_AddWidget ( void * this , muGUIwidget * fWid );
void muGUI_ClearScreen (  void * this ) ;
void muGUI_defaultIdleProc ( void ) ;


void PrintToEmuOutput (  char * ftext );
void PrintToOpcodeOutput (  char * ftext );
void PrintToRegistersOutput (  char * ftext ) ;