/**
 * nSX2 - an OpenSource PS2 Emulator
 * Copyright (C) 2002 Muad
 *
 * homepage: http://nsx2.emulation64.com
 * email address: atreides.muaddib@caramail.com
 * 
 * If you want to contribute to the project please contact
 * me first (maybe someone is already making what you are
 * planning to do).
 *
 *
 * This program is free software; you can redistribute it and/
 * or modify it under the terms of the GNU General Public Li-
 * cence as published by the Free Software Foundation; either
 * version 2 of the Licence, or any later version.
 *
 * This program is distributed in the hope that it will be use-
 * ful, but WITHOUT ANY WARRANTY; without even the implied war-
 * ranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public Licence for more details.
 *
 * You should have received a copy of the GNU General Public
 * Licence along with this program; if not, write to the Free
 * Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139,
 * USA.
 *
**/

void SPECIAL	();
void REGIMM		();
void J			();
void JAL		(); 
void BEQ		(); 
void BNE		(); 
void BLEZ		(); 
void BGTZ		();
void ADDI		(); 
void ADDIU		(); 
void SLTI		(); 
void SLTIU		(); 
void ANDI		(); 
void ORI		(); 
void XORI		(); 
void LUI		();
void COP0		(); 
void COP1		(); 
void COP2		();
void COP1X		();
void BEQL		(); 
void BNEL		(); 
void BLEZL		(); 
void BGTZL		();
void DADDI		(); 
void DADDIU		(); 
void LDL		(); 
void LDR		(); 
void SPECIAL2	(); 
void JALX		(); 
void LQ			();
void MDMX		(); 
void NI			();
void LB			(); 
void LH			(); 
void LWL		(); 
void LW			(); 
void LBU		(); 
void LHU		(); 
void LWR		(); 
void LWU		();
void SB			(); 
void SH			(); 
void SWL		(); 
void SW			(); 
void SDL		(); 
void SDR		(); 
void SWR		(); 
void CACHE		();
void LL			(); 
void LWC1		(); 
void LWC2		(); 
void PREF		(); 
void LLD		(); 
void LDC1		(); 
void LDC2		(); 
void LD			();
void SC			(); 
void SWC1		(); 
void SWC2		(); 
void SQ			(); 
void SCD		(); 
void SDC1		(); 
void SDC2		(); 
void SD			();


void SLL		(); 
void MOVCI		(); 
void SRL		(); 
void SRA		(); 
void SLLV		(); 
void SLRV		(); 
void SRAV		();
void JR			(); 
void JALR		(); 
void MOVZ		(); 
void MOVN		(); 
void SYSCALL	(); 
void BREAK		(); 
void SYNC		();
void MFHI		(); 
void MTHI		(); 
void MFLO		(); 
void MTLO		(); 
void DSLLV		(); 
void DSRLV		(); 
void DSRAV		();
void MULT		(); 
void MULTU		(); 
void DIV		(); 
void DIVU		(); 
void DMULT		(); 
void DMULTU		(); 
void DDIV		(); 
void DDIVU		();
void ADD		(); 
void ADDU		(); 
void SUB		(); 
void SUBU		(); 
void AND		(); 
void OR			(); 
void XOR		(); 
void NOR		();
void SLT		(); 
void SLTU		(); 
void DADD		(); 
void DADDU		(); 
void DSUB		(); 
void DSUBU		();
void TGE		(); 
void TGEU		(); 
void TLT		(); 
void TLTU		(); 
void TEQ		(); 
void TNE		(); 
void DSLL		(); 
void DSRL		(); 
void DSRA		(); 
void DSLL32		(); 
void DSRL32		(); 
void DSRA32		();

void BLTZ(); 
void BGEZ(); 
void BLTZL   (); 
void BGEZL  (); 
void TGEI   (); 
void TGEIU (); 
void TLTI(); 
void TLTIU(); 
void TEQI(); 
void TNEI (); 
void BLTZAL   (); 
void BGEZAL  (); 
void BLTZALL  (); 
void BGEZALL  ();

void MFC0  ();
void DMFC0  ();
void MTC0  ();
void DMTC0  ();
void C0   ();


void TLBR(); 	
void TLBWI();
void TLBWR();	
void TLBP();		
void ERET(); 
void DERET ();	 
void WAIT();
void EI(); 	
void DI(); 	
	  
void SYSCALL_RFU000_FullReset( );
void SYSCALL_ResetEE( );
void SYSCALL_SetGsCrt( );
void SYSCALL_RFU003( );
void SYSCALL_Exit( );
void SYSCALL_RFU005( );
void SYSCALL_LoadPS2Exe( );
void SYSCALL_ExecPS2( );
void SYSCALL_RFU008( );
void SYSCALL_RFU009( );
void SYSCALL_AddSbusIntcHandler( );
void SYSCALL_RemoveSbusIntcHandler( );
void SYSCALL_Interrupt2Iop( );
void SYSCALL_SetVTLBRefillHandler( );
void SYSCALL_SetVCommonHandler( );
void SYSCALL_SetVInterruptHandler( );
void SYSCALL_AddIntcHandler( );
void SYSCALL_RemoveIntcHandler( );
void SYSCALL_AddDmacHandler( );
void SYSCALL_RemoveDmacHandler( );
void SYSCALL__EnableIntc( );
void SYSCALL__DisableIntc( );
void SYSCALL__EnableDmac( );
void SYSCALL__DisableDmac( );
void SYSCALL__SetAlarm( );
void SYSCALL__ReleaseAlarm( );
void SYSCALL_NI( );
void SYSCALL_CreateThread( );
void SYSCALL_DeleteThread( );
void SYSCALL_StartThread( );
void SYSCALL_ExitThread( );
void SYSCALL_ExitDeleteThread( );
void SYSCALL_TerminateThread( );
void SYSCALL_DisableDispatchThread( );
void SYSCALL_EnableDispatchThread( );
void SYSCALL_ChangeThreadPriority( );
void SYSCALL_RotateThreadReadyQueue( );
void SYSCALL_ReleaseWaitThread( );
void SYSCALL_GetThreadId( );
void SYSCALL_ReferThreadStatus( );
void SYSCALL_SleepThread( );
void SYSCALL_WakeupThread( );
void SYSCALL_CancelWakeupThread( );
void SYSCALL_SuspendThread( );
void SYSCALL_ResumeThread( );
void SYSCALL_JoinThread( );
void SYSCALL_RFU060( );
void SYSCALL_RFU061( );
void SYSCALL_EndOfHeap( );
void SYSCALL_RFU063( );
void SYSCALL_CreateSema( );
void SYSCALL_DeleteSema( );
void SYSCALL_SignalSema( );
void SYSCALL_WaitSema( );
void SYSCALL_PollSema( );
void SYSCALL_ReferSemaStatus( );
void SYSCALL_RFU073( );
void SYSCALL_SetOsdConfigParam( );
void SYSCALL_GetOsdConfigParam( );
void SYSCALL_GetGsHParam( );
void SYSCALL_GetGsVParam( );
void SYSCALL_SetGsHParam( );
void SYSCALL_SetGsVParam( );
void SYSCALL_RFU080_CreateEventFlag( );
void SYSCALL_RFU081_DeleteEventFlag( );
void SYSCALL_RFU082_SetEventFlag( );
void SYSCALL_RFU083_iSetEventFlag( );
void SYSCALL_RFU084_ClearEventFlag( );
void SYSCALL_RFU085_iClearEventFlag( );
void SYSCALL_RFU086_WaitEvnetFlag( );
void SYSCALL_RFU087_PollEvnetFlag( );
void SYSCALL_RFU088_iPollEvnetFlag( );
void SYSCALL_RFU089_ReferEventFlagStatus( );
void SYSCALL_RFU091( );
void SYSCALL_EnableIntcHandler( );
void SYSCALL_DisableIntcHandler( );
void SYSCALL_EnableDmacHandler( );
void SYSCALL_DisableDmacHandler( );
void SYSCALL_KSeg0( );
void SYSCALL_EnableCache( );
void SYSCALL_DisableCache( );
void SYSCALL_GetCop0( );
void SYSCALL_FlushCache( );
void SYSCALL_CpuConfig( );
void SYSCALL_sceSifStopDma( );
void SYSCALL_SetCPUTimerHandler( );
void SYSCALL_SetCPUTimer( );
void SYSCALL_ForceRead( );
void SYSCALL_ForceWrite( );
void SYSCALL_GsGetIMR( );
void SYSCALL_GsPutIMR( );
void SYSCALL_SetPgifHandler( );
void SYSCALL_SetVSyncFlag( );
void SYSCALL_RFU116( );
void SYSCALL_print( );
void SYSCALL_sceSifDmaStat( );
void SYSCALL_sceSifSetDma( );
void SYSCALL_sceSifSetDChain( );
void SYSCALL_sceSifSetReg( );
void SYSCALL_sceSifGetReg( );
void SYSCALL_ExecOSD( );
void SYSCALL_Deci2Call( );
void SYSCALL_PSMode( );
void SYSCALL_MachineType( );
void SYSCALL_GetMemorySize( );
void SYSCALL_isceSifSetDChain( );
void SYSCALL_isceSifSetDma( );
void SYSCALL_isceSifDmaStat( );
void SYSCALL_iGsPutIMR( );
void SYSCALL_iGsGetIMR( );
void SYSCALL_iCpuConfig( );
void SYSCALL_iFlushCache( );
void SYSCALL_iGetCop0( );
void SYSCALL_iDisableDmacHandler( );
void SYSCALL_iEnableDmacHandler( );
void SYSCALL_iDisableIntcHandler( );
void SYSCALL_iEnableIntcHandler( );
void SYSCALL_RFU090_iReferEventFlagStatus( );
void SYSCALL_iReferSemaStatus( );
void SYSCALL_iPollSema( );
void SYSCALL_iSignalSema( );
void SYSCALL_iResumeThread( );
void SYSCALL_iSuspendThread( );
void SYSCALL_iCancelWakeupThread( );
void SYSCALL_iWakeupThread( );
void SYSCALL_iReferThreadStatus( );
void SYSCALL_iReleaseWaitThread( );
void SYSCALL_iRotateThreadReadyQueue( );
void SYSCALL_iChangeThreadPriority( );
void SYSCALL_iTerminateThread( );
void SYSCALL__iReleaseAlarm( );
void SYSCALL__iSetAlarm( );
void SYSCALL__iDisableDmac( );
void SYSCALL__iEnableDmac( );
void SYSCALL__iDisableIntc( );
void SYSCALL__iEnableIntc( );
void SYSCALL_UKN_1();

void MADD( );
		
void MADDU( );
void MUL( );
void MULT1( );
void MSUB( );
void MSUBU( );
void CLZ( );
void CLO( );
void DLCZ( );
void DLCO( );
void SDBBP( );



void MFC1( );
void DMFC1( );	
void CFC1( );			
void MTC1( );	
void DMTC1( );	
void CTC1( );	
void BC1( );	 		
void COP1_S( );
void COP1_D( );	
void COP1_W( );
void COP1_L( );




	


void BC1F( ); 
void BC1T( );
void BC1FL( );
void BC1TL( );

void ADD_S( ); 		
void SUB_S( ); 		
void MUL_S( ); 		
void DIV_S( ); 		
void SQRT_S( ); 	
void ABS_S( ); 		
void MOV_S( ); 		
void NEG_S( );
void ROUND_L_S( );	
void TRUNC_L_S( );	
void CEIL_L_S( );	
void FLOOR_L_S( );	
void ROUND_W_S( );	
void TRUNC_W_S( );	
void CEIL_W_S( );	
void FLOOR_W_S( );
void MOVCF_S( );	
void MOVZ_S( );		
void MOVN_S( );		
void RECIP_S( );  	
void RSQRT_S( );  	
void CVT_D_S( );		
void CVT_W_S( );	
void CVT_L_S( );	
void C_F_S( ); 		
void C_UN_S( );		
void C_EQ_S( );		
void C_UEQ_S( );	
void C_OLT_S( );	
void C_ULT_S( );	
void C_OLE_S( );	
void C_ULE_S( );
void C_SF_S( );		
void C_NGLE_S( ); 	
void C_SEQ_S( );	
void C_NGL_S( );	
void C_LT_S( );		
void C_NGE_S( );	
void C_LE_S( );		
void C_NGT_S( );



void ADD_D( );		
void SUB_D( );		
void MUL_D( );		
void DIV_D( );		
void SQRT_D( );		
void ABS_D( );		
void MOV_D( );		
void NEG_D( );
void ROUND_L_D( );	
void TRUNC_L_D( );	
void CEIL_L_D( );	
void FLOOR_L_D( );	
void ROUND_W_D( );	
void TRUNC_W_D( );	
void CEIL_W_D( );	
void FLOOR_W_D( );
void MOVCF_D( );	
void MOVZ_D( );		
void MOVN_D( );				
void RECIP_D( );	
void RSQRT_D( );
void CVT_S_D( );	
void CVT_W_D( );	
void CVT_L_D( );	
void C_F_D( );		
void C_UN_D( );		
void C_EQ_D( );		
void C_UEQ_D( );	
void C_OLT_D( );	
void C_ULT_D( );	
void C_OLE_D( );	
void C_ULE_D( );
void C_SF_D( );		
void C_NGLE_D( );	
void C_SEQ_D( );	
void C_NGL_D( );	
void C_LT_D( );		
void C_NGE_D( );	
void C_LE_D( );		
void C_NGT_D( );


void CVT_S( );		
void CVT_D( );			


void MOVF_fmt( ); 
void MOVT_fmt( );	
